package fi.em.formPlugin;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.entity.botp.plugin.AbstractConvertPlugIn;
import kd.bos.entity.botp.plugin.args.BeforeBuildRowConditionEventArgs;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.sdk.plugin.Plugin;
//业务处理单基础资料选单过滤插件
public class BusinessProcessingConvertPlugIn extends AbstractConvertPlugIn implements Plugin {
    @Override
    public void beforeBuildRowCondition(BeforeBuildRowConditionEventArgs e) {
        //获取页面插件传递过来的操作参数
        String orgnumber = this.getOption().getVariableValue("orgnumber");
        String jsonArray = this.getOption().getVariableValue("JSONArray");
        JSONArray objects = JSONArray.parseArray(jsonArray);
        String type = this.getOption().getVariableValue("type");//1
        if("drawyfgz".equals(type)){
            String bdsupplier = this.getOption().getVariableValue("bdsupplier");
            String billtype = this.getOption().getVariableValue("billtype");
            QFilter numberQFilter = new QFilter("ap_finapbill.org.number", QCP.equals, orgnumber);
//            numberQFilter.and("ap_finapbill.asstacttype", QCP.equals, billtype);
            numberQFilter.and("ap_finapbill.asstact.id", QCP.equals, Long.valueOf(bdsupplier));
            for(int i=0;i<objects.size();i++){
                JSONObject jsonObject = objects.getJSONObject(i);
                String id = jsonObject.getString("id");
                numberQFilter.and("ap_finapbill.id", QCP.not_equals2, Long.valueOf(id));
            }
            e.getCustQFilters().add(numberQFilter);
        }else if("drawysgz".equals(type)){
            String bdsupplier = this.getOption().getVariableValue("bdsupplier");
            String billtype = this.getOption().getVariableValue("billtype");
            QFilter numberQFilter = new QFilter("ar_finarbill.org.number", QCP.equals, orgnumber);
//            numberQFilter.and("ar_finarbill.asstacttype", QCP.equals, billtype);
            numberQFilter.and("ar_finarbill.asstact.id", QCP.equals, Long.valueOf(bdsupplier));
            for(int i=0;i<objects.size();i++){
                JSONObject jsonObject = objects.getJSONObject(i);
                String id = jsonObject.getString("id");
                numberQFilter.and("ar_finarbill.id", QCP.not_equals2, Long.valueOf(id));
            }
            e.getCustQFilters().add(numberQFilter);
        }else if("drawzlht".equals(type)){
            String bdsupplier = this.getOption().getVariableValue("bdsupplier");
            String billtype = this.getOption().getVariableValue("billtype");
            QFilter numberQFilter = new QFilter("fa_lease_contract.org.number", QCP.equals, orgnumber);
//            numberQFilter.and("fa_lease_contract.asstacttype", QCP.equals, billtype);
            numberQFilter.and("fa_lease_contract.leaser.number", QCP.equals, bdsupplier);
            for(int i=0;i<objects.size();i++){
                JSONObject jsonObject = objects.getJSONObject(i);
                String id = jsonObject.getString("id");
                numberQFilter.and("fa_lease_contract.number", QCP.not_equals2, id);
            }
            e.getCustQFilters().add(numberQFilter);
        }else if("draw-yf".equals(type)){
            QFilter numberQFilter = new QFilter("er_prepaybill.costdept.number", QCP.equals, orgnumber);
            for(int i=0;i<objects.size();i++){
                JSONObject jsonObject = objects.getJSONObject(i);
                String id = jsonObject.getString("id");
                numberQFilter.and("er_prepaybill.billno", QCP.not_equals2, id);
            }
            e.getCustQFilters().add(numberQFilter);
        }else if("draw-ssysd".equals(type)){
            QFilter numberQFilter = new QFilter("ar_finarbill.org.number", QCP.equals, orgnumber);
            for(int i=0;i<objects.size();i++){
                JSONObject jsonObject = objects.getJSONObject(i);
                String id = jsonObject.getString("id");
                numberQFilter.and("ar_finarbill.id", QCP.not_equals2, Long.valueOf(id));
            }
            e.getCustQFilters().add(numberQFilter);
        }
        super.beforeBuildRowCondition(e);
    }
}
