package fi.em.formPlugin;

import com.alibaba.druid.util.StringUtils;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.entity.datamodel.events.ChangeData;
import kd.bos.entity.datamodel.events.PropertyChangedArgs;
import kd.bos.form.plugin.AbstractFormPlugin;
import kd.bos.orm.query.QCP;
import kd.bos.orm.query.QFilter;
import kd.bos.servicehelper.BusinessDataServiceHelper;

public class BusinessProcessingSplitPlugin extends AbstractFormPlugin {

    @Override
    public void propertyChanged(PropertyChangedArgs e) {
        String fieldKey = e.getProperty().getName();
        if (StringUtils.equals("nckd_basedatafield19", fieldKey)) {
            //获取变更的数据
            ChangeData changeData = e.getChangeSet()[0];
            DynamicObject dynamicObject = (DynamicObject) changeData.getNewValue();
            this.getModel().deleteEntryData("nckd_entryentity6112");
            if (dynamicObject != null) {
                DynamicObject realCard = dynamicObject.getDynamicObject("realcard");
                String number = realCard.getString("number");
                QFilter filter = new QFilter("nckd_card_real_code", QCP.equals,number);
                DynamicObject[] dynamicObjects = BusinessDataServiceHelper.load("nckd_fa_card_real_list","id",new QFilter[] {filter});
                int rowIndex = this.getModel().createNewEntryRow("nckd_entryentity6112");
                this.getModel().setValue("nckd_combofield5", "拆分前", 0);
                if (dynamicObjects.length > 0) {
                    this.getView().setVisible(false, "nckd_advconbaritemap61");
                    this.getView().setVisible(false, "nckd_advconbaritemap6");
                    this.getView().setVisible(true, "nckd_card");
                    this.getView().setEnable(false, "nckd_integerfield1");
                    this.getModel().setValue("nckd_integerfield1", dynamicObjects.length);
                }else {
                    this.getView().setVisible(true, "nckd_advconbaritemap61");
                    this.getView().setVisible(true, "nckd_advconbaritemap6");
                    this.getView().setVisible(false, "nckd_card");
                    this.getView().setEnable(true, "nckd_integerfield1");
                    this.getModel().setValue("nckd_integerfield1", 0);
                }
            }
        }
    }
}
