package fi.em.formPlugin;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import kd.bos.dataentity.entity.DynamicObject;
import kd.bos.dataentity.entity.DynamicObjectCollection;
import kd.bos.entity.EntityMetadataCache;
import kd.bos.exception.KDBizException;
import kd.bos.form.events.AfterDoOperationEventArgs;
import kd.bos.form.events.BeforeDoOperationEventArgs;
import kd.bos.form.operate.botp.Draw;
import kd.bos.list.plugin.AbstractListPlugin;
import kd.bos.servicehelper.BusinessDataServiceHelper;
import kd.sdk.plugin.Plugin;

import java.util.ArrayList;
import java.util.List;

public class TravelChargePrepaidLoanEditPlugin extends AbstractListPlugin implements Plugin {
    @Override
    public void beforeDoOperation(BeforeDoOperationEventArgs args) {
        if (args.getSource() instanceof Draw) {
            Draw draw = (Draw) args.getSource();
            if (draw.getOperateKey().equals("draw-yf")) {
//                Object value = this.getModel().getValue("nckd_payeenamev");//获取当前单据付款人
                Object nckd_orgv = this.getModel().getValue("costdept");//获取当前单据付款人
//                DynamicObject dynamicObject = (DynamicObject) value;
                DynamicObject orgv = (DynamicObject) nckd_orgv;
                if (orgv == null) {
                    throw new KDBizException("费用承担公司为空！");
                }
                DynamicObjectCollection nckdEntryentity1 = this.getModel().getEntryEntity("nckd_clearloanentry");
                JSONArray jSONArray = new JSONArray();
                for(int i=0;i<nckdEntryentity1.size();i++){
                    JSONObject jsonObject = new JSONObject();
                    DynamicObject dynamicObject1 = nckdEntryentity1.get(i);
                    String nckdTextfield7 = dynamicObject1.getString("nckd_billno");
                    jsonObject.put("id",nckdTextfield7);
                    jSONArray.add(jsonObject);
                }
                draw.getOption().setVariableValue("JSONArray", jSONArray.toString());
                String orgnumber = orgv.getString("number");
                draw.getOption().setVariableValue("orgnumber", orgnumber);
                draw.getOption().setVariableValue("type", "draw-yf");
            }
        }
    }

}
